//	listing:	1
//	file:		ttexample.cpp
//	author:		Allan Kelly
#include <ostream.h>
#include "threadtemplate.h"

class Worker
{
public:
	enum ClassConstants { TopNumber = 2500, sqr = 50 };

private:
	int m_id;
	short m_list[TopNumber+1];

public:
	Worker(int id) : m_id(id)
	{
		cout << "Worker " << m_id << " ctor" << endl;

		for (int i = 0; i < TopNumber; i++)
		{
			m_list[i] = 0;
		}
	}

	void Write()
	{
		cout << "This is Worker" << m_id << endl;
	}

	void Run()
	{
		m_list[0] = 1;
		for (long i = 2; i < sqr; i++)
		{
			for (long j = (i+1); j < TopNumber; j++)
			{
				if ( 0 == (j % i) )
				{	// force threads out of step
					m_list[j] = 1; 
					Sleep(4);
				}

				if (1 == m_id)
				{	// show something is happening
					cout << ".";
				}
				else
				{
					cout << "O";
				}
			}
		}
	}

	void Print()
	{
		cout << endl << "Primes are....." << endl;
		for (int i = 0; i < TopNumber; i++)
		{
			if (0 == m_list[i])
			{
				cout << i << ", ";
			}
		}
		cout << endl;
	}

};

int main()
{
	cout << "Main...." << endl;

	// create my workers
	Worker w1(1);
	{
		// create my thread handler
		ThreadTemplate<Worker> thread1;

		// run my worker
		thread1.RunThread(w1);

		// create and run another worker
		Sleep(2);
		ThreadTemplate<Worker> thread2;
		Worker w2(2);
		thread2.RunThread(w2);

		// will not be allowed out of scope until finished
	}

	// retrieve data from worker
	w1.Print();
	return 0;
}

